 
 SUBROUTINE fgeosub( Point, A, In )
 
 DOUBLE PRECISION, INTENT(IN), DIMENSION(1:3)  :: Point
 DOUBLE PRECISION, INTENT(IN), DIMENSION(1:20) :: A
 INTEGER,          INTENT(INOUT) :: In
 
 DOUBLE PRECISION :: Pi, Phi, P
 DOUBLE PRECISION :: x, y, z, z0, z1, zz, az, rmz, oodL, a01, a10
!! DOUBLE PRECISION :: fAdaCOS

    Pi= 4*ATAN(1.0d0)
 

    IF (NINT(A(1)) == 1) THEN
       x= Point(1)
       y= Point(2)
       z= Point(3)
       P = A(4)+A(5)*z
       Phi= A(2)*(x**2-y**2) &
          + A(3)*(x**2+y**2+(P/Pi)**2)*wbCos(2*Pi*z/P)

       IF (A(8) > 0) THEN
          IF (Phi > A(9)) THEN
             In= 1
          ELSE
             In= 0
          END IF
       ELSE
          IF (Phi < A(9)) THEN
             In= 1
          ELSE
             In= 0
          END IF
       END IF
    ELSE IF (NINT(A(1)) == 2) THEN
 
! a1,a2,a3,a4,a5,a6,a7,a8,a9 => A( 1: 9)
! b1,b2,b3,b4,b5,b6,b7,b8,b9 => A(11:19)
 
!      Periode als Polynom dargestellt,
!      Amplituden als Polynom dargestellt,
!      Abschnittsweise
 
       x= Point(1)
       y= Point(2)
       z= Point(3)
       z0= A(2)
       z1= A(3)
!c      write (*,*) ' a(1:9):', a(1:9)
!c      write (*,*) ' a(11:19):', a(11:19)
       IF ((z < z0) .OR. (z > z1)) THEN
          In= 0
          RETURN
       END IF
       zz= z-z0
       oodL= 1 / (z1-z0)
       P = A(4) +zz*(A(5)-A(4))*oodL
       az= A(6) +zz*(A(7)-A(6))*oodL
       rmz= A(8)+zz*(A(9)-A(8))*oodL
       a10= (rmz**2-1) &
          / (2*(rmz*az)**2+(rmz**2+1)*(P/Pi)**2)
       a01= ((rmz**2+1)*az**2+2*(P/Pi)**2) &
          / (2*(rmz*az)**2+(rmz**2+1)*(P/Pi)**2) &
          / az**2
       Phi= a01*(x**2-y**2) &
          + a10*(x**2+y**2+(P/Pi)**2)*wbCos(2*Pi*zz/P)

       IF (A(11) > 0) THEN
          IF (Phi > A(12)) THEN
             In= 1
          ELSE
             In= 0
          END IF
       ELSE
          IF (Phi < A(12)) THEN
             In= 1
          ELSE
             In= 0
          END IF
       END IF
 
    ELSE
       In= 0
    END IF

 CONTAINS

    DOUBLE PRECISION FUNCTION wbCos( x )
    DOUBLE PRECISION, INTENT(IN) :: x

    DOUBLE PRECISION :: xx

       xx= ABS(x)
       DO WHILE (xx > 2*Pi)
          xx= xx - 2*Pi
       END DO

       IF (xx > Pi) THEN
          Vorzeichen= -1
          xx= xx - Pi
       ELSE
          Vorzeichen= 1
       END IF

       IF (xx > Pi/2) THEN
          Vorzeichen= -Vorzeichen
          xx= Pi - xx
       END IF


       wbCos= Vorzeichen* &
           (1 - xx**2/2 + xx**4/(2*3*4) - xx**6 / (2.*3.*4.*5.*6.) )
       !!       + xx**8 / (2.*3.*4.*5.*6.*7.*8.) &
       !!       - xx**10 / (2.d0*3.d0*4.d0*5.d0*6.d0*7.d0*8.d0*9.d0*10.d0) )

    END FUNCTION wbCos

 END SUBROUTINE fgeosub

