 PROGRAM a3dBrillo
!
! /usr/local/gd1/examples-from-the-manual/a3dbrillo.f
!
! usage:
!
! cat brillo.part=[1-4].mtv | a.out
! mymtv2 3D-brillo.mtv
!
 REAL, DIMENSION(1:300, 1:1000) :: f0
 REAL, DIMENSION(1:1000) :: ph0
 REAL, DIMENSION(1:100) :: Phase0, scale
 CHARACTER(LEN= 1000) :: str
 INTEGER :: i11, i19, iostat, nMode, np, Mode
 REAL :: af, ap, PhaseLast

    i11= 11
    i19= 19
    OPEN (UNIT= i19, &
          FILE= '3D-brillo.mtv')

    WRITE (UNIT= i19, FMT= 90)
 90 FORMAT( &
       '$ DATA= CURVE2D NAME= "Brillouin-Diagramm"', /, &
       '% linetype= 0', /, &
       '% markertype= 3', /, &
       '% equalscale= false', /, &
       '% fitpage= false', /, &
       '% xyratio= 3', /, &
       '% xlabel= "normalised Phase-shift"', /, &
       '% ylabel= "Frequency"', /, &
       '% comment= "no comment"',/ )

    af= 0.
    ap= 0.

    NMode= 10

    Phase0(1:4)= (/ 0.0, &
                    1.0, &
                    2.0, &
                    4.0  /)
    scale(1:4)= (/ 1./180.0, &   !! Gamma to H
                   1./180.0, &   !!     H to N
                   1./180.0, &   !!     N to P
                  -1./180.0 /)   !!     P to Gamma

    PhaseLast= 0.
    np= 1
    str= ' '
    DO
       DO
          IF (INDEX(str, '# Phase:') /= 0) THEN
             jj= INDEX(str, '# Phase:')+LEN('# Phase:')
             READ (UNIT= str(jj:), FMT= *) Phase
             IF (Phase < PhaseLast) THEN
                np= np+1
             ENDIF
             PhaseLast= Phase
             EXIT
          END IF
          READ (UNIT= *, FMT= '(A)', END= 10) str
       END DO
  write (*,*) ' Phase:', Phase
       pp= Phase0(np)
       ph0(np)= pp+Phase*scale(np)

       mode= 0
       DO mode= 1, NMode, 1
          READ (UNIT= *, FMT= '(A)', END= 10) str
          READ (UNIT= str(2:), FMT= *, IOSTAT= iostat) f
          IF (iostat /= 0) EXIT
    write (*,*) ' pp, f:', pp+Phase*scale(np), f
          f0(mode,np)= f
          WRITE (UNIT= i19, FMT= 71) pp+Phase*scale(np),f
          af= MAX(af,f)
          ap= MAX(ap,pp+Phase*scale(np))
       END DO
    END DO
 10 CONTINUE

 71 FORMAT( &
      '@ point x1=', 1P, E12.6,' y1=',E12.6,' z1= 0 markertype=1', &
      ' markersize= 1' )

    WRITE (UNIT= i19, FMT= *)
    WRITE (UNIT= i19, FMT= 99) 0., 0., 0., af, ap, af
 99 FORMAT(1P, 3(' ', 2(E12.6, ' '), /), /)

 END PROGRAM a3dBrillo
