!
! /usr/local/gd1/examples-from-the-manual/brillo.f90
!
 PROGRAM Bla

 IMPLICIT NONE
 CHARACTER(LEN= 400) cmd

 REAL, DIMENSION(1:300,1:1000) :: f0
 REAL, DIMENSION(1:1000) :: ph0

 INTEGER :: i11, i19, NMode, np, ip, Mode, iDum
 REAL :: af, ap, p0, p1, Phase, Acc, f

    i11= 11
    i19= 19
    OPEN (UNIT= i19, &
          FILE= 'brillo.mtv')

    WRITE (UNIT= i19, FMT= 90)
 90 FORMAT( &
      '$ DATA= CURVE2D NAME= "Brillouin-Diagramm"', /, &
      '% linetype= 0', /, &
      '% markertype= 3', /, &
      '% equalscale= false', /, &
      '% fitpage= false', /, &
      '% xyratio= 3', /, &
      '% xlabel= "Phase-shift"', /, &
      '% ylabel= "Frequency"', /, &
      '% comment= "no comment"', /  )

    af= 0
    ap= 0

    NMode= 15

! p0: First Phase
! p1: Last Phase
! np: Number of Phases

    p0= 0.
    p1= 180.
    np= 41

    DO ip= 1, np, 1
       Phase= p0 + (ip-1)*(p1-p0)/(np-1)
       ph0(ip)= Phase
       WRITE (UNIT= cmd, FMT= 81) Phase
 81    FORMAT( &
         ' gd1  "-DPHASE=', F8.2, '"< brillo.gdf ', &
         '| tee brillo.tmp | grep "for me" > brillo.out' )
 write (UNIT= 0, FMT= '(1X,4711(A))') ' cmd:', TRIM(cmd)
       CALL system( cmd )
       OPEN (UNIT= i11, &
             FILE= 'brillo.out')
       Mode= 0
       DO
          READ (UNIT= i11, FMT= *, ERR= 199, END= 199) iDum, f, acc
          IF (acc < 0.5) THEN
             Mode= Mode + 1
             IF (Mode <= NMode) THEN
                f0(Mode,ip)= f
             END IF
             WRITE (UNIT= i19, FMT= 71) Phase,f
 write (0,*) Phase, f, acc
             af= MAX(af, f)
             ap= MAX(ap, Phase)
          END IF
       END DO
 199   CONTINUE
       CLOSE (UNIT= i11)
    END DO

 71 FORMAT( '@ point x1=', 1P, E12.6, ' y1=', E12.6, &
            ' z1= 0 markertype=1', ' markersize= 1' )

    DO Mode= 1, NMode, 1
       WRITE (UNIT= i19, FMT= *)
       DO ip= 1, np, 1
          WRITE (UNIT= i19, FMT= *) ph0(ip), f0(Mode,ip)
       END DO
    END DO
    WRITE (UNIT= i19, FMT= *)
    WRITE (UNIT= i19, FMT= 99) 0., 0., 0., af, ap, af
 99 FORMAT( 3(1X, 1P, 2(E12.6, 1X), /), /)

    !**
    !** Write the uninterpreted Data.
    !**
    DO ip= 1, np, 1
       WRITE (UNIT= i19, FMT= '(//,A,F14.2)') ' # Phase:', ph0(ip)
       DO Mode= 1, NMode, 1
          WRITE (UNIT= i19, FMT= '(A,1X,1P,E20.7)') '#', f0(Mode,ip)
       END DO
    END DO

 END PROGRAM Bla

